import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TicTacToeWorld extends World
{
    private int [][] board;
    int current_player = Constant.PLAYER1;
    /**
     * Constructor for objects of class TicTacToeWorld.
     * 
     */
    public TicTacToeWorld()
    {    
        // Create a new world with 3x3 cells with a cell size of 90 pixels.
        super(3, 3, 90); 
        board = new int [3][3];

        for (int i=0;i<3;i++)
        {
            for (int j=0;j<3;j++)
            {
                board[i][j] = 0;
            }
        }
        buildBoard();
    }

    public void act()
    {
        makeMove();
        
        checkGameOver();
    }

    public void checkGameOver()
    {
        checkWinner();
        checkTie();

    }

    public void checkWinner()
    {
        int product = 1;
        for(int i=0;i<3;i++)
        {
            product = board[i][0] * board [i][1] * board [i][2];
            if(product == 1 || product == 8)
            {
                Greenfoot.stop();
            }
            product = board[0][i] * board [1][i] * board [2][i];
            if(product == 1 || product == 8)
            {
                Greenfoot.stop();
            }
            product = board[0][0]*board[1][1]*board[2][2];
            if(product == 1 || product == 8)
            {
                Greenfoot.stop();
            }
            product = board[0][2]*board[1][1]*board[2][0];
            if(product == 1 || product == 8)
            {
                Greenfoot.stop();
            }
        }
    }

    public void checkTie()
    {
        int product = 1;
        for(int i=0;i<3;i++)

        {
            for(int j=0;j<3;j++)
            {
                product = product * board[i][j];
            }
        }
        if(product !=0 )
        {
            Greenfoot.stop();
        }
    }

    public void makeMove()
    {
        int x, y;
        //x = -1;
        //y = -1;

        if(Greenfoot.mouseClicked(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();

            x = mouse.getX();
            y = mouse.getY();

            if(current_player == Constant.PLAYER1)
            {
                Player1 p1 = new Player1();
                addObject(p1, x,y);
                board[x][y] = Constant.PLAYER1;
                current_player = Constant.PLAYER2;

            }
            else
            {
                Player2 p2 = new Player2();
                addObject(p2, x,y);
                board[x][y] = Constant.PLAYER2;
                current_player = Constant.PLAYER1;

            }
        }
    }

    public void buildBoard()
    {
        Square sq = new Square(Color.BLACK);

        for (int i=0;i<3;i++)
        {
            for(int j=0;j<3;j++)
            {
                if((i+j) % 2 == 0)
                {
                    sq=new Square(Color.WHITE);
                }
                else
                {
                    sq=new Square(Color.BLACK);
                }
                addObject(sq,i,j);
            }

        }

    }
}
